<?php

/**
 * @package		Article Images Upload and Gallery
 * @author		Andrey Miasoedov (molotow11@gmail.com)
 * @license		GNU/GPL license: http://www.gnu.org/copyleft/gpl.html
 */

// no direct access
defined('_JEXEC') or die('Restricted access');
/*
jimport('joomla.plugin.plugin');
jimport('joomla.html.parameter');
jimport('joomla.version');
jimport('joomla.filesystem.file');
jimport('joomla.filesystem.folder');
*/

use Joomla\CMS\Factory;
use Joomla\CMS\Router\Route;
use Joomla\Component\Content\Administrator\Extension\ContentComponent;
use Joomla\Component\Content\Site\Helper\RouteHelper;
use Joomla\Component\Content\Site\Helper\AssciationHelper;

class plgSystemArticleimagesgalleryck extends JPlugin {

	protected $gallery_triggered_count;

	protected $extra_options;

	/**
	 * @param       JForm   The form to be altered.
	 * @param       array   The associated data for the form.
	 * @return      boolean
	 */
	public function onContentPrepareForm($form, $data) {

		if (
			// condition for the module - add source of plugins
			$form->getName() != 'com_content.article'
		)
			return;

			JForm::addFormPath(JPATH_SITE . '/plugins/system/articleimagesgalleryck/params');
			JForm::addFieldPath(JPATH_ROOT . '/plugins/system/articleimagesgalleryck/elements');

			// get the language
			$lang = JFactory::getLanguage();
			$langtag = $lang->getTag(); // returns fr-FR or en-GB
			$this->loadLanguage();

			// add options
			$form->loadFile('articleimagesgalleryck', false);
			if (! isset($data->images['imagestabimages']) && ! empty($data)) {
				$this->backCompatibility($data);
			}
	}

	function backCompatibility(&$data) {
		// get images from old imagestab plugin
		$db = JFactory::getDbo();

		// check it table exists
		$tablesList = $db->getTableList();
		$tableExists = in_array($db->getPrefix() . 'content_images_data', $tablesList);
		if (! $tableExists) return;

		$query = "SELECT * FROM #__content_images_data WHERE article_id = " . $data->id . " ORDER BY 'order' ASC";

		$db->setQuery($query);
		$images = $db->loadObjectList();

		if (! $images) return;

		$data->images['imagestabimages'] = array();
		$i = 0;
		foreach ($images as $image) {
			$data->images['imagestabimages']['imagestabimages' . $i] = array(
				'image' => 'images/' . $image->filename,
				'caption' => $image->caption,
				'credits' => $image->credits
			);
			$i++;
		}
	}

	function onAfterRoute() {
		/*$app = JFactory::getApplication();
		$db = JFactory::getDBO();
		$option = JFactory::getApplication()->input->get("option");
		$view = JFactory::getApplication()->input->get("view");
		$task = JFactory::getApplication()->input->get("task");
		$layout = JFactory::getApplication()->input->get("layout");
		

		$plugin = JPluginHelper::getPlugin('system', 'imagestab');
		$plgParams = new JRegistry($plugin->params);
		// $img_path = $plgParams->get("img_path", "images/articles");
		*/

		$pluginPath = JPATH_SITE . '/plugins/system/articleimagesgalleryck/imagestab';
		//Editors button action
		if (JFactory::getApplication()->input->get("ImagestabButtonGallery")) {
			require($pluginPath . '/templates/buttonGallery.php');
			die;
		}
	}
	
	function prepareFileName($string) {
		$string = preg_replace('~[^\\pL0-9_]+~u', '-', $string); // substitutes anything but letters, numbers and '_' with separator 
		$string = trim($string, "-");
		$string = strtolower($string);
		$string = preg_replace('~[^-a-z0-9_]+~', '', $string); // keep only letters, numbers, '_' and separator
		return $string;
	}

	//images display function (frontend)
	function onContentBeforeDisplay($context, &$article) {
		$component = JFactory::getApplication()->input->get("option");
		if(!in_array($component, array("com_content", "com_tags"))) return;
		if(property_exists($article, 'extension')) return; //category description event

		$view = JFactory::getApplication()->input->get('view', 'category');
		$view == 'article' ? $context = 'com_content.article' : $context = 'com_content.category';
		//gsearch fix
		if(JFactory::getApplication()->input->get("gsearch")) {
			$context = 'com_content.category';
		}
		
		
		//single image placements
		$regex = '/{ArticleImagesGallery (.*)}/i';
		preg_match_all($regex, $article->text, $matches_single);
		if(count($matches_single[0])) {
			foreach($matches_single[0] as $k=>$images_code) {
				$gallery_parameters = explode(" ", $matches_single[1][$k]);
				$images_numbers = explode(",", $gallery_parameters[0]);
				unset($gallery_parameters[0]);
				$this->extra_options = implode(" ", $gallery_parameters);
			
				$single_gallery = $this->renderGallery('com_content.article', $article, $images_numbers);
				$article->text = str_replace($images_code, $single_gallery, $article->text);
				if($context == 'com_content.category') {
					$article->introtext = str_replace($images_code, $single_gallery, $article->introtext);
				}				
			}
		}
		
		//full gallery
		$regex = '/{ArticleImagesGallery}/i';
		preg_match_all($regex, $article->text, $matches, PREG_SET_ORDER);
		$this->extra_options = null;
		$gallery = $this->renderGallery($context, $article);

		if ($matches) {
			//output by code in article's text
			$article->text = preg_replace($regex, $gallery, $article->text);
			//category fix
			if($context == 'com_content.category') {
				$article->introtext = preg_replace($regex, $gallery, $article->introtext);
				return;
			}
		}
		else {
			//category fix
			if($context == 'com_content.category'
				&& !count($matches_single[0])
			) {
				return $gallery;
			}
			if(count($matches_single[0])) return; //do not show standard gallery if single gallery code applied	
			//standard output by template event
			return $gallery;
		}
	}
	
	function renderGallery($context, $article, $images_numbers = array()) {
		$app = JFactory::getApplication();
		$db = JFactory::getDBO();
		$pluginPathSite = JURI::root().'/plugins/system/articleimagesgalleryck/imagestab';
		$document = JFactory::getDocument();
		$document->addStyleSheet($pluginPathSite.'/assets/css/articleimagesgalleryck.css');

		$plugin = JPluginHelper::getPlugin('system', 'articleimagesgalleryck');
		$plgParams = class_exists('JParameter') ? new JParameter($plugin->params) : new JRegistry($plugin->params);
		$template = $plgParams->get("template", "slider");
		if(isset($_GET['gallery_template'])) {
			$template = $_GET['gallery_template'];
		}
		$jquery = (int)$plgParams->get("jquery", "1");	
		$firstImageArticle = $plgParams->get("firstImageArticle", "full");	
		$full_size_article = $plgParams->get("full_size", "");	
		$firstImageCategory = $plgParams->get("firstImageCategory", "thumb");
		$thumb_size = $plgParams->get("thumb_size", "100");
		
		$return = '';

		if (! isset($article->images)) return '';

		// get images from the articles options
		$params = json_decode($article->images);
		$images = array();
		$order = 1;
		if (! isset($params->imagestabimages) || empty($params->imagestabimages)) {
			return '';
		}

		foreach ($params->imagestabimages as $i) {
			$image = new stdClass();
			$image->path = $i->image;
			$image->filename = $i->image;
			$image->caption = $i->caption;
			$image->credits = $i->credits;
			$image->order = $order;
			$images[] = $image;

			$order++;
		}

		//category listing
		if($context == 'com_content.category' && $firstImageCategory != "none") { 
			//back compatibility
			foreach($images as $image) {
				$parts = explode("/", $image->filename);
				$image->filename = $parts[count($parts) - 1];
				if(strpos($image->filename, '.') === false) {
					$image->filename = $image->filename . '.jpg';
				}
			}
			
			if(count($images)) {
				switch($firstImageCategory) {
					case "gallery" :
						$pluginPath = JPATH_SITE.'/plugins/system/articleimagesgalleryck/imagestab';
						switch($template) {
							case "slider" :
								$thumb_height = $plgParams->get("thumb_height", "65");
								$thumb_fit = $plgParams->get("thumb_fit", "cover");	
								$slider_captions = $plgParams->get("slider_captions", "1");	
								$slider_fit = $plgParams->get("slider_fit", "contain");	
								$slider_loop = $plgParams->get("slider_loop", "true");	
								$slider_autoplay = $plgParams->get("slider_autoplay", "false");	
								$slider_transition = $plgParams->get("slider_transition", "slide");	
								$slider_duration = $plgParams->get("slider_duration", "1000");	
							
								ob_start();
								if(file_exists(JPATH_SITE.'/templates/'.$app->getTemplate().'/html/articleimagesgalleryck/slider.php')) {
									//template override
									require(JPATH_SITE.'/templates/'.$app->getTemplate().'/html/articleimagesgalleryck/slider.php');
								}
								else if(file_exists(JPATH_SITE.'/templates/'.$app->getTemplate().'/html/imagestab/slider.php')) {
									//template override
									require(JPATH_SITE.'/templates/'.$app->getTemplate().'/html/imagestab/slider.php');
								}
								else {
									require($pluginPath.'/templates/article/slider.php');
								}
								$return .= ob_get_contents();
								ob_end_clean();
								$GLOBALS['gallery_triggered_count_category'] += 1;
							break;
							
							case "highslide" :
							case "raw" :
								ob_start();
								if(file_exists(JPATH_SITE."/templates/{$app->getTemplate()}/html/articleimagesgalleryck/{$template}.php")) {
									//template override
									require(JPATH_SITE."/templates/{$app->getTemplate()}/html/articleimagesgalleryck/{$template}.php");
								}
								else if(file_exists(JPATH_SITE."/templates/{$app->getTemplate()}/html/imagestab/{$template}.php")) {
									//template override
									require(JPATH_SITE."/templates/{$app->getTemplate()}/html/imagestab/{$template}.php");
								}
								else {
									require($pluginPath."/templates/article/{$template}.php");
								}
								$return .= ob_get_contents();
								ob_end_clean();
								$GLOBALS['gallery_triggered_count_category'] += 1;
							break;
						}
						break;
					case "full" :
					default :
						$img_path = JURI::root() . $plgParams->get("img_path", "images/articles");
						if($plgParams->get("img_path_separate")) {
							$img_path .= '/article' . $article->id;
						}
						if($firstImageCategory == "full") {
							$pathSite = $img_path . "/src/" . $images[0]->filename;
						}
						else {
							$pathSite = $img_path . "/thumb/" . $images[0]->filename;
						}
						
						if(JFactory::getApplication()->input->get("option") == "com_tags") {
							$article_link = JURI::root() . "component/content/article/{$article->id}-{$article->core_alias}";
						}
						else {
							$article_link = JRoute::_(ContentHelperRoute::getArticleRoute($article->slug, @$article->catslug)); 
							if(version_compare(JVERSION, '3.0', 'lt')) {
								$article_link = JRoute::_(ContentHelperRoute::getArticleRoute($article->slug, $article->catid));
							}
						}
						$return .= "<div class='category_article_image'>";
						$return .= "<a href='{$article_link}' title='{$article->title}'><img src='{$pathSite}' alt='{$article->title}' /></a>";
						$return .= "</div>";
				}
			}			
		}

		//article view
		if($context == 'com_content.article') {
			// load only called images
			if(! empty($images_numbers)) {
		
				$this->images_numbers = $images_numbers;
				$images = array_filter($images, function($k) {
					return in_array($k+1, $this->images_numbers);
				}, ARRAY_FILTER_USE_KEY);
			}

			//backward compatibility
			foreach($images as $image) {
				$parts = explode("/", $image->filename);
				$image->filename = $parts[count($parts) - 1];
				if(strpos($image->filename, '.') === false) {
					$image->filename = $image->filename . '.jpg';
				}
			}
			
			if (count($images)) {
				$this->gallery_triggered_count += 1;
				$pluginPath = JPATH_SITE.'/plugins/system/articleimagesgalleryck/imagestab';
				switch($template) {
					case "slider" :
						$thumb_height = $plgParams->get("thumb_height", "65");	
						$thumb_fit = $plgParams->get("thumb_fit", "cover");	
						$slider_captions = $plgParams->get("slider_captions", "1");	
						$slider_fit = $plgParams->get("slider_fit", "contain");	
						$slider_loop = $plgParams->get("slider_loop", "true");	
						$slider_autoplay = $plgParams->get("slider_autoplay", "false");	
						$slider_transition = $plgParams->get("slider_transition", "slide");	
						$slider_duration = $plgParams->get("slider_duration", "1000");	
					
						ob_start();
						if(file_exists(JPATH_SITE.'/templates/'.$app->getTemplate().'/html/articleimagesgalleryck/slider.php')) {
							//template override
							require(JPATH_SITE.'/templates/'.$app->getTemplate().'/html/articleimagesgalleryck/slider.php');
						}
						else if(file_exists(JPATH_SITE.'/templates/'.$app->getTemplate().'/html/imagestab/slider.php')) {
							//template override
							require(JPATH_SITE.'/templates/'.$app->getTemplate().'/html/imagestab/slider.php');
						} else {
							require($pluginPath.'/templates/article/slider.php');
						}
						$return .= ob_get_contents();
						ob_end_clean();
					break;	
					
					case "highslide" :
					case "raw" :
						ob_start();
						if(file_exists(JPATH_SITE."/templates/{$app->getTemplate()}/html/articleimagesgalleryck/{$template}.php")) {
							//template override
							require(JPATH_SITE."/templates/{$app->getTemplate()}/html/articleimagesgalleryck/{$template}.php");
						}
						else if(file_exists(JPATH_SITE."/templates/{$app->getTemplate()}/html/imagestab/{$template}.php")) {
							//template override
							require(JPATH_SITE."/templates/{$app->getTemplate()}/html/imagestab/{$template}.php");
						}
						else {
							require($pluginPath."/templates/article/{$template}.php");
						}
						$return .= ob_get_contents();
						ob_end_clean();
					break;
				}
			}
		}
		
		return $return;
	}
}

?>